<?php

namespace EventPortal\Domain\Table;

use EventPortal\Domain\Table\Factories\TableFactory;
use Illuminate\Support\Arr;

class TableRegistry
{
    /** @var array<string> */
    private $tables = [];

    public function make(string $tableName): TableFactory
    {
        if (Arr::has($this->tables, $tableName)) {
            return $this->tables[$tableName];
        }

        $this->tables[$tableName] = new TableFactory;

        return $this->tables[$tableName];
    }
}
