<?php

namespace EventPortal\Tests\Feature\Admin\Delegate;

use EventPortal\Domain\Delegate\Models\Delegate;
use EventPortal\Tests\Support\Traits\SeedRolesAndPermissions;
use EventPortal\Tests\TestCase;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Spatie\Snapshots\MatchesSnapshots;

class DelegateStoreTest extends TestCase
{
    use RefreshDatabase, MatchesSnapshots, SeedRolesAndPermissions;

    /** @test **/
    public function can_store_a_delegate(): void
    {
        $this
            ->actingAsSuperAdmin()
            ->followingRedirects()
            ->post(route('admin.delegate.store'), [
                'first_name' => 'firstName',
                'last_name' => 'lastName',
                'email' => 'delegate@example.com',
            ])
            ->assertOk();
        $delegate = Delegate::first();
        $this->assertEquals(route('admin.delegate.show', $delegate), url()->current());

        $this->assertEquals('firstName', $delegate->user->first_name);
        $this->assertEquals('lastName', $delegate->user->last_name);
        $this->assertEquals('delegate@example.com', $delegate->user->email);
    }
}
